From 323efec6202c24505571f40d9d429c55dc3f8a96 Mon Sep 17 00:00:00 2001
From: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
Date: Wed, 14 Nov 2018 11:29:47 +0530
Subject: [PATCH 07/18] mistral: Add eMMC support

Enable eMMC support on Mistral.

Change-Id: I59230c5503982c18fce20f748e3e917b86b5604e
Signed-off-by: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
Signed-off-by: Nitheesh Sekar <nsekar@codeaurora.org>
---
 board/mistral/defconfig   |  4 ++++
 src/board/mistral/board.c | 20 ++++++++++++++++++++
 2 files changed, 24 insertions(+)

diff --git a/board/mistral/defconfig b/board/mistral/defconfig
index 77851e85b21b..aeb0852fb763 100644
--- a/board/mistral/defconfig
+++ b/board/mistral/defconfig
@@ -24,6 +24,10 @@ CONFIG_KERNEL_FIT_FDT_ADDR=0xB0000000
 #CONFIG_DRIVER_TPM_SPI is not set
 CONFIG_DRIVER_FLASH_SPI=y
 CONFIG_DRIVER_INPUT_USB=y
+#eMMC/SD-card
+CONFIG_DRIVER_STORAGE_MMC=y
+CONFIG_DRIVER_SDHCI=y
+CONFIG_DRIVER_STORAGE_SDHCI_MSM=y
 
 CONFIG_DRIVER_GPIO_QCS405=y
 # VIDEO
diff --git a/src/board/mistral/board.c b/src/board/mistral/board.c
index 9f487df8bd41..e9d019d24515 100644
--- a/src/board/mistral/board.c
+++ b/src/board/mistral/board.c
@@ -26,6 +26,13 @@
 #include "drivers/bus/spi/qcs405.h"
 #include "drivers/bus/usb/usb.h"
 #include "drivers/power/psci.h"
+#include "drivers/storage/sdhci_msm.h"
+
+#define TLMM_BOOT_SEL		0x010C1000
+#define EMMC_BOOT		0x8000000
+#define SDC1_HC_BASE		0x07804000
+#define SDC1_TLMM_CFG_ADDR	0x10C2000
+
 
 static const VpdDeviceTreeMap vpd_dt_map[] = {
 	{ "cherokee_mac", "/soc@0/wifi@a000000/local-mac-address" },
@@ -91,6 +98,19 @@ static int board_setup(void)
 	SpiFlash *flash = new_spi_flash(&spi_flash->ops);
 	flash_set_ops(&flash->ops);
 #endif
+	/* eMMC support */
+	/* DATA pins are muxed between NAND and EMMC, configure them to eMMC */
+	writel(EMMC_BOOT, (uint32_t *)TLMM_BOOT_SEL);
+
+	SdhciHost *emmc = new_sdhci_msm_host((void *)SDC1_HC_BASE,
+					SDHCI_PLATFORM_EMMC_1V8_POWER |
+					SDHCI_PLATFORM_NO_EMMC_HS200,
+					100*MHz,
+					(void *)SDC1_TLMM_CFG_ADDR,
+					NULL);
+	assert(emmc);
+	list_insert_after(&emmc->mmc_ctrlr.ctrlr.list_node,
+			&fixed_block_dev_controllers);
 
 	return 0;
 }
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

